/*
 This file was autogenerated by tags.py 
 */

#import "GCDataAttribute.h"

#import "GCTagAccessAdditions.h"
#import "GCObject_internal.h"
#import "Gedcom_internal.h"

@implementation GCDataAttribute {
	GCDateAttribute *_date;
	NSMutableArray *_texts;
}

// Methods:
/// @name Initializing

/** Initializes and returns a data.

 
 @return A new data.
*/
+(instancetype)data
{
	return [[self alloc] init];
}
/// @name Initializing

/** Initializes and returns a data.

 @param value The value as a GCValue object.
 @return A new data.
*/
+(instancetype)dataWithValue:(GCValue *)value
{
	return [[self alloc] initWithValue:value];
}
/// @name Initializing

/** Initializes and returns a data.

 @param value The value as an NSString.
 @return A new data.
*/
+(instancetype)dataWithGedcomStringValue:(NSString *)value
{
	return [[self alloc] initWithGedcomStringValue:value];
}
- (instancetype)init
{
	self = [super init];
	
	if (self) {
		// initialize ivars, if any:
		_texts = [NSMutableArray array];
	}
	
	return self;
}


// Properties:

- (id)date
{
	return _date;
}
	
- (void)setDate:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCDataAttribute *)[uM prepareWithInvocationTarget:self] setDate:_date];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_date) {
		[(id)_date setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_date = obj;
}

@synthesize texts = _texts;

@dynamic mutableTexts;
- (NSMutableArray *)mutableTexts
{
	return [self mutableArrayValueForKey:@"texts"];
}

- (id)objectInTextsAtIndex:(NSUInteger)idx
{
	return [_texts objectAtIndex:idx];
}

- (NSUInteger)countOfTexts
{
	return [_texts count];
}

- (void)insertObject:(id)obj inTextsAtIndex:(NSUInteger)idx
{
	if ([obj valueForKey:@"describedObject"] == self) {
		return;
	}
	
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCDataAttribute *)[uM prepareWithInvocationTarget:self] removeObjectFromTextsAtIndex:idx];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if ([obj valueForKey:@"describedObject"]) {
		[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	}
	
	[obj setValue:self forKey:@"describedObject"];
	
	[_texts insertObject:obj atIndex:idx];
}

- (void)removeObjectFromTextsAtIndex:(NSUInteger)idx
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCDataAttribute *)[uM prepareWithInvocationTarget:self] insertObject:_texts[idx] inTextsAtIndex:idx];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	[_texts[idx] setValue:nil forKey:@"describedObject"];
	
	[_texts removeObjectAtIndex:idx];
}


@end
