/*
 This file was autogenerated by tags.py 
 */

#import "GCSubmissionRecord.h"

#import "GCTagAccessAdditions.h"
#import "GCObject_internal.h"
#import "Gedcom_internal.h"

@implementation GCSubmissionRecord {
	GCSubmitterReferenceRelationship *_submitterReference;
	GCFamilyFileAttribute *_familyFile;
	GCTempleAttribute *_temple;
	GCGenerationsOfAncestorsAttribute *_generationsOfAncestors;
	GCGenerationsOfDescendantsAttribute *_generationsOfDescendants;
	GCOrdinanceFlagAttribute *_ordinanceFlag;
	NSMutableArray *_userReferenceNumbers;
	GCRecordIdNumberAttribute *_recordIdNumber;
	GCChangeInfoAttribute *_changeInfo;
}

// Methods:
/// @name Initializing

/** Initializes and returns a submission.

 @param context The context in which to create the entity.
 @return A new submission.
*/
+(instancetype)submissionInContext:(GCContext *)context
{
	return [[self alloc] initInContext:context];
}
- (instancetype)initInContext:(GCContext *)context
{
	self = [super initInContext:context];
	
	if (self) {
		// initialize ivars, if any:
		_userReferenceNumbers = [NSMutableArray array];
	}
	
	return self;
}


// Properties:

- (id)submitterReference
{
	return _submitterReference;
}
	
- (void)setSubmitterReference:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setSubmitterReference:_submitterReference];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_submitterReference) {
		[(id)_submitterReference setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_submitterReference = obj;
}


- (id)familyFile
{
	return _familyFile;
}
	
- (void)setFamilyFile:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setFamilyFile:_familyFile];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_familyFile) {
		[(id)_familyFile setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_familyFile = obj;
}


- (id)temple
{
	return _temple;
}
	
- (void)setTemple:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setTemple:_temple];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_temple) {
		[(id)_temple setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_temple = obj;
}


- (id)generationsOfAncestors
{
	return _generationsOfAncestors;
}
	
- (void)setGenerationsOfAncestors:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setGenerationsOfAncestors:_generationsOfAncestors];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_generationsOfAncestors) {
		[(id)_generationsOfAncestors setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_generationsOfAncestors = obj;
}


- (id)generationsOfDescendants
{
	return _generationsOfDescendants;
}
	
- (void)setGenerationsOfDescendants:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setGenerationsOfDescendants:_generationsOfDescendants];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_generationsOfDescendants) {
		[(id)_generationsOfDescendants setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_generationsOfDescendants = obj;
}


- (id)ordinanceFlag
{
	return _ordinanceFlag;
}
	
- (void)setOrdinanceFlag:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setOrdinanceFlag:_ordinanceFlag];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_ordinanceFlag) {
		[(id)_ordinanceFlag setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_ordinanceFlag = obj;
}

@synthesize userReferenceNumbers = _userReferenceNumbers;

@dynamic mutableUserReferenceNumbers;
- (NSMutableArray *)mutableUserReferenceNumbers
{
	return [self mutableArrayValueForKey:@"userReferenceNumbers"];
}

- (id)objectInUserReferenceNumbersAtIndex:(NSUInteger)idx
{
	return [_userReferenceNumbers objectAtIndex:idx];
}

- (NSUInteger)countOfUserReferenceNumbers
{
	return [_userReferenceNumbers count];
}

- (void)insertObject:(id)obj inUserReferenceNumbersAtIndex:(NSUInteger)idx
{
	if ([obj valueForKey:@"describedObject"] == self) {
		return;
	}
	
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] removeObjectFromUserReferenceNumbersAtIndex:idx];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if ([obj valueForKey:@"describedObject"]) {
		[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	}
	
	[obj setValue:self forKey:@"describedObject"];
	
	[_userReferenceNumbers insertObject:obj atIndex:idx];
}

- (void)removeObjectFromUserReferenceNumbersAtIndex:(NSUInteger)idx
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] insertObject:_userReferenceNumbers[idx] inUserReferenceNumbersAtIndex:idx];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	[_userReferenceNumbers[idx] setValue:nil forKey:@"describedObject"];
	
	[_userReferenceNumbers removeObjectAtIndex:idx];
}


- (id)recordIdNumber
{
	return _recordIdNumber;
}
	
- (void)setRecordIdNumber:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setRecordIdNumber:_recordIdNumber];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_recordIdNumber) {
		[(id)_recordIdNumber setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_recordIdNumber = obj;
}


- (id)changeInfo
{
	return _changeInfo;
}
	
- (void)setChangeInfo:(id)obj
{
	if (!_isBuildingFromGedcom) {
		NSUndoManager *uM = [self valueForKey:@"undoManager"];
		@synchronized (uM) {
			[uM beginUndoGrouping];
			[(GCSubmissionRecord *)[uM prepareWithInvocationTarget:self] setChangeInfo:_changeInfo];
			[uM setActionName:[NSString stringWithFormat:GCLocalizedString(@"Undo %@", @"Misc"), self.localizedType]];
			[uM endUndoGrouping];
		}
	}
	
	if (_changeInfo) {
		[(id)_changeInfo setValue:nil forKey:@"describedObject"];
	}
	
	[[obj valueForKeyPath:@"describedObject.mutableProperties"] removeObject:obj];
	
	[obj setValue:self forKey:@"describedObject"];
	
	_changeInfo = obj;
}


@end
